<template>
  <form @submit.prevent="handleSubmit">
    <div class="space-y-12">
      <h2 class="text-base font-semibold leading-7 text-gray-900">Create a post</h2>

      <div class="border-b border-gray-900/10 pb-12">
        <div class="mt-10 grid grid-cols-1 gap-x-6 gap-y-8 sm:grid-cols-6">
          <div class="col-span-full">
            <label for="postTitle" class="block text-sm font-medium leading-6 text-gray-900">Post title</label>
            <div class="mt-2">
              <input data-testid="title" type="text" name="postTitle" id="postTitle" autocomplete="postTitle"
                v-model="title" required v-focus
                class="pl-3 block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
              <p v-show="errors.title" data-testid="errorTitle" class="text-red-600">{{ errors.title }}</p>
            </div>
          </div>

          <div class="col-span-full">
            <label for="categories" class="block text-sm font-medium leading-6 text-gray-900">Categories</label>
            <div class="mt-2">
              <input type="text" name="categories" id="categories" autocomplete="categories" v-model="tempCategory"
                @keyup.,="addCategory" data-testid="categories"
                class="pl-3 block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
              <p v-show="errors.categories" data-testid="errorCategory" class="text-red-600">{{ errors.categories }}</p>
            </div>
            <div data-testid="categoryContainer">
              <span @click="deleteCategory(category)" v-for="category in categories" :key="category"
                class="inline-flex mt-3 mr-3 items-center rounded-md bg-gray-50 px-2 py-1 text-xs font-medium text-gray-600 ring-1 ring-inset ring-gray-500/10 hover:cursor-pointer">
                {{ category }}
              </span>
            </div>
          </div>
        </div>
      </div>

      <div class="border-b border-gray-900/10 pb-12">
        <div class="mt-10 grid grid-cols-1 gap-x-6 gap-y-8 sm:grid-cols-6">
          <div class="col-span-full">
            <label for="message" class="block text-sm font-medium leading-6 text-gray-900">Message</label>
            <div class="mt-2">
              <textarea id="message" name="message" rows="3" v-model="message" data-testid="message" required
                class="pl-3 block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
              <p v-show="errors.message" data-testid="errorMessage" class="text-red-600">{{ errors.message }}</p>
            </div>
          </div>
        </div>
      </div>
    </div>

    <div class="mt-6 flex items-center justify-end gap-x-6">
      <a href="/">
        <button type="button"
          class="rounded-md bg-gray-300 px-3 py-2 text-sm font-semibold text-gray-900 shadow-sm hover:bg-gray-200 focus-visible:outline focus-visible:outline-2 focus-visible:outline-offset-2 focus-visible:outline-gray-300 leading-6">
          Cancel
        </button>
      </a>
      <button type="submit" data-testid="btnSubmit"
        class="rounded-md bg-indigo-600 px-3 py-2 text-sm font-semibold text-white shadow-sm hover:bg-indigo-500 focus-visible:outline focus-visible:outline-2 focus-visible:outline-offset-2 focus-visible:outline-indigo-600">
        Save
      </button>
    </div>
  </form>
</template>

<script>
export default {
  data() {
    return {
      title: '',
      tempCategory: '',
      categories: [],
      message: '',
      errors: {},
    }
  },
  methods: {
    handleSubmit() {
      if (!this.title.trim()) {
        this.errors.title = 'You have to put title to your post';
      }

      if (!this.categories.length) {
        this.errors.categories = 'You have to put at least 1 catergory';
      }

      if (!this.message.trim()) {
        this.errors.message = 'You have to write a message';
      }

      if (!this.errors) {
        console.log('succeed');
      }
    },
    addCategory() {
      let category = this.tempCategory.split(',')[0].trim()
      if (category) {
        if (category.length > 1) {
          if (!this.categories.includes(category)) {
            this.categories.push(category);
          }
        } else {
          this.errors.categories = 'A category name must contain more than one char'
        }
        this.tempCategory = '';
      } else {
        this.errors.categories = 'A category can not be empty'
        this.tempCategory = '';
      }
    },
    deleteCategory(pCategory) {
      this.categories = this.categories.filter((c) => pCategory !== c);
    }
  },
}
</script>